
// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqobject.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <signalmanager.h>
#include <pysidemetafunction.h>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyfalkon_python.h"

// main header
#include "sitesettingsmanager_wrapper.h"

// inner classes
#include "sitesettingsmanager_sitesettings_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>

// Native ---------------------------------------------------------

void SiteSettingsManagerWrapper::pysideInitQtMetaTypes()
{
    qRegisterMetaType< ::SiteSettingsManager::Permission >("SiteSettingsManager::Permission");
    qRegisterMetaType< ::SiteSettingsManager::PageOptions >("SiteSettingsManager::PageOptions");
}

void SiteSettingsManagerWrapper::resetPyMethodCache()
{
    std::fill_n(m_PyMethodCache, sizeof(m_PyMethodCache) / sizeof(m_PyMethodCache[0]), false);
}

SiteSettingsManagerWrapper::SiteSettingsManagerWrapper(::QObject * parent) : SiteSettingsManager(parent)
{
    resetPyMethodCache();
    // ... middle
}

void SiteSettingsManagerWrapper::childEvent(::QChildEvent * event)
{
    if (m_PyMethodCache[0]) {
        return this->::QObject::childEvent(event);
    }
    Shiboken::GilState gil;
    if (Shiboken::Errors::occurred() != nullptr)
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "childEvent";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        m_PyMethodCache[0] = true;
        gil.release();
        return this->::QObject::childEvent(event);
    }

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API)
    PyObject *pyArgArray[1] = {
        Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QChildEvent_IDX]), event)
    };

    const bool invalidateArg1 = Py_REFCNT(pyArgArray[0]) == 1;
#else
    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
        Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QChildEvent_IDX]), event)
    ));
    bool invalidateArg1 = Py_REFCNT(PyTuple_GET_ITEM(pyArgs, 0)) == 1;
#endif

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API)
    Shiboken::AutoDecRef pyResult(PyObject_Vectorcall(pyOverride, pyArgArray, 1, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(pyArgArray[0]);
    Py_DECREF(pyArgArray[0]);
#else
    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
#endif
    if (pyResult.isNull()) {
        // An error happened in python code!
        Shiboken::Errors::storeErrorOrPrint();
        return;
    }
}

void SiteSettingsManagerWrapper::connectNotify(const ::QMetaMethod & signal)
{
    if (m_PyMethodCache[1]) {
        return this->::QObject::connectNotify(signal);
    }
    Shiboken::GilState gil;
    if (Shiboken::Errors::occurred() != nullptr)
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "connectNotify";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        m_PyMethodCache[1] = true;
        gil.release();
        return this->::QObject::connectNotify(signal);
    }

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API)
    PyObject *pyArgArray[1] = {
        Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaMethod_IDX]), &signal)
    };
#else
    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
        Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaMethod_IDX]), &signal)
    ));
#endif

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API)
    Shiboken::AutoDecRef pyResult(PyObject_Vectorcall(pyOverride, pyArgArray, 1, nullptr));
    Py_DECREF(pyArgArray[0]);
#else
    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
#endif
    if (pyResult.isNull()) {
        // An error happened in python code!
        Shiboken::Errors::storeErrorOrPrint();
        return;
    }
}

void SiteSettingsManagerWrapper::customEvent(::QEvent * event)
{
    if (m_PyMethodCache[2]) {
        return this->::QObject::customEvent(event);
    }
    Shiboken::GilState gil;
    if (Shiboken::Errors::occurred() != nullptr)
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "customEvent";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        m_PyMethodCache[2] = true;
        gil.release();
        return this->::QObject::customEvent(event);
    }

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API)
    PyObject *pyArgArray[1] = {
        Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QEvent_IDX]), event)
    };

    const bool invalidateArg1 = Py_REFCNT(pyArgArray[0]) == 1;
#else
    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
        Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QEvent_IDX]), event)
    ));
    bool invalidateArg1 = Py_REFCNT(PyTuple_GET_ITEM(pyArgs, 0)) == 1;
#endif

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API)
    Shiboken::AutoDecRef pyResult(PyObject_Vectorcall(pyOverride, pyArgArray, 1, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(pyArgArray[0]);
    Py_DECREF(pyArgArray[0]);
#else
    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
#endif
    if (pyResult.isNull()) {
        // An error happened in python code!
        Shiboken::Errors::storeErrorOrPrint();
        return;
    }
}

void SiteSettingsManagerWrapper::disconnectNotify(const ::QMetaMethod & signal)
{
    if (m_PyMethodCache[3]) {
        return this->::QObject::disconnectNotify(signal);
    }
    Shiboken::GilState gil;
    if (Shiboken::Errors::occurred() != nullptr)
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "disconnectNotify";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        m_PyMethodCache[3] = true;
        gil.release();
        return this->::QObject::disconnectNotify(signal);
    }

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API)
    PyObject *pyArgArray[1] = {
        Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaMethod_IDX]), &signal)
    };
#else
    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
        Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaMethod_IDX]), &signal)
    ));
#endif

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API)
    Shiboken::AutoDecRef pyResult(PyObject_Vectorcall(pyOverride, pyArgArray, 1, nullptr));
    Py_DECREF(pyArgArray[0]);
#else
    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
#endif
    if (pyResult.isNull()) {
        // An error happened in python code!
        Shiboken::Errors::storeErrorOrPrint();
        return;
    }
}

bool SiteSettingsManagerWrapper::event(::QEvent * event)
{
    if (m_PyMethodCache[4])
        return this->::QObject::event(event);
    Shiboken::GilState gil;
    if (Shiboken::Errors::occurred() != nullptr)
        return false;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "event";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        m_PyMethodCache[4] = true;
        gil.release();
        return this->::QObject::event(event);
    }

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API)
    PyObject *pyArgArray[1] = {
        Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QEvent_IDX]), event)
    };

    const bool invalidateArg1 = Py_REFCNT(pyArgArray[0]) == 1;
#else
    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
        Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QEvent_IDX]), event)
    ));
    bool invalidateArg1 = Py_REFCNT(PyTuple_GET_ITEM(pyArgs, 0)) == 1;
#endif

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API)
    Shiboken::AutoDecRef pyResult(PyObject_Vectorcall(pyOverride, pyArgArray, 1, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(pyArgArray[0]);
    Py_DECREF(pyArgArray[0]);
#else
    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
#endif
    if (pyResult.isNull()) {
        // An error happened in python code!
        Shiboken::Errors::storeErrorOrPrint();
        return false;
    }
    // Check return type
    Shiboken::Conversions::PythonToCppConversion pythonToCpp =
        Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), pyResult);
    if (!pythonToCpp) {
        Shiboken::Warnings::warnInvalidReturnValue("SiteSettingsManager", funcName, "bool", Py_TYPE(pyResult)->tp_name);
        return false;
    }
    bool cppResult;
    pythonToCpp(pyResult, &cppResult);
    return cppResult;
}

bool SiteSettingsManagerWrapper::eventFilter(::QObject * watched, ::QEvent * event)
{
    if (m_PyMethodCache[5])
        return this->::QObject::eventFilter(watched, event);
    Shiboken::GilState gil;
    if (Shiboken::Errors::occurred() != nullptr)
        return false;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "eventFilter";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        m_PyMethodCache[5] = true;
        gil.release();
        return this->::QObject::eventFilter(watched, event);
    }

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API)
    PyObject *pyArgArray[2] = {
        Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), watched),
        Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QEvent_IDX]), event)
    };

    const bool invalidateArg2 = Py_REFCNT(pyArgArray[1]) == 1;
#else
    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(NN)",
        Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), watched),
        Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QEvent_IDX]), event)
    ));
    bool invalidateArg2 = Py_REFCNT(PyTuple_GET_ITEM(pyArgs, 1)) == 1;
#endif

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API)
    Shiboken::AutoDecRef pyResult(PyObject_Vectorcall(pyOverride, pyArgArray, 2, nullptr));
    if (invalidateArg2)
        Shiboken::Object::invalidate(pyArgArray[1]);
    Py_DECREF(pyArgArray[0]);
    Py_DECREF(pyArgArray[1]);
#else
    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (invalidateArg2)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 1));
#endif
    if (pyResult.isNull()) {
        // An error happened in python code!
        Shiboken::Errors::storeErrorOrPrint();
        return false;
    }
    // Check return type
    Shiboken::Conversions::PythonToCppConversion pythonToCpp =
        Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), pyResult);
    if (!pythonToCpp) {
        Shiboken::Warnings::warnInvalidReturnValue("SiteSettingsManager", funcName, "bool", Py_TYPE(pyResult)->tp_name);
        return false;
    }
    bool cppResult;
    pythonToCpp(pyResult, &cppResult);
    return cppResult;
}

void SiteSettingsManagerWrapper::timerEvent(::QTimerEvent * event)
{
    if (m_PyMethodCache[6]) {
        return this->::QObject::timerEvent(event);
    }
    Shiboken::GilState gil;
    if (Shiboken::Errors::occurred() != nullptr)
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "timerEvent";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        m_PyMethodCache[6] = true;
        gil.release();
        return this->::QObject::timerEvent(event);
    }

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API)
    PyObject *pyArgArray[1] = {
        Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTimerEvent_IDX]), event)
    };

    const bool invalidateArg1 = Py_REFCNT(pyArgArray[0]) == 1;
#else
    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
        Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTimerEvent_IDX]), event)
    ));
    bool invalidateArg1 = Py_REFCNT(PyTuple_GET_ITEM(pyArgs, 0)) == 1;
#endif

#if !defined(PYPY_VERSION) && !defined(Py_LIMITED_API)
    Shiboken::AutoDecRef pyResult(PyObject_Vectorcall(pyOverride, pyArgArray, 1, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(pyArgArray[0]);
    Py_DECREF(pyArgArray[0]);
#else
    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
#endif
    if (pyResult.isNull()) {
        // An error happened in python code!
        Shiboken::Errors::storeErrorOrPrint();
        return;
    }
}

const QMetaObject *SiteSettingsManagerWrapper::metaObject() const
{
    if (QObject::d_ptr->metaObject != nullptr)
        return QObject::d_ptr->dynamicMetaObject();
    SbkObject *pySelf = Shiboken::BindingManager::instance().retrieveWrapper(this);
    if (pySelf == nullptr)
        return SiteSettingsManager::metaObject();
    return PySide::SignalManager::retrieveMetaObject(reinterpret_cast<PyObject *>(pySelf));
}

int SiteSettingsManagerWrapper::qt_metacall(QMetaObject::Call call, int id, void **args)
{
    int result = SiteSettingsManager::qt_metacall(call, id, args);
    return result < 0 ? result : PySide::SignalManager::qt_metacall(this, call, id, args);
}

void *SiteSettingsManagerWrapper::qt_metacast(const char *_clname)
{
    if (_clname == nullptr)
        return {};
    SbkObject *pySelf = Shiboken::BindingManager::instance().retrieveWrapper(this);
    if (pySelf != nullptr && PySide::inherits(Py_TYPE(pySelf), _clname))
        return static_cast<void *>(const_cast< SiteSettingsManagerWrapper *>(this));
    return SiteSettingsManager::qt_metacast(_clname);
}

SiteSettingsManagerWrapper::~SiteSettingsManagerWrapper()
{
    SbkObject *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this);
    Shiboken::Object::destroy(wrapper, this);
}

// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_SiteSettingsManager_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    const QMetaObject *metaObject;
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::SiteSettingsManager >()))
        return -1;

    SiteSettingsManagerWrapper *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.SiteSettingsManager.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_ParseTuple(args, "|O:SiteSettingsManager", &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: SiteSettingsManager::SiteSettingsManager(QObject*=)
    if (numArgs == 0) {
        overloadId = 0; // SiteSettingsManager(QObject*)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArgs[0])))) {
        overloadId = 0; // SiteSettingsManager(QObject*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    bool usesPyMI = Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_parent = Shiboken::String::createStaticString("parent");
            if (PyDict_Contains(kwds, key_parent) != 0) {
                value = PyDict_GetItem(kwds, key_parent);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_parent);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArgs[0]))))
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_parent);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                // fall through to handle extra keyword signals and properties
            }
        }
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return -1;
        ::QObject *cppArg0 = nullptr;
        if (pythonToCpp[0])
            pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // SiteSettingsManager(QObject*)
            void *addr = PySide::nextQObjectMemoryAddr();
            if (addr != nullptr) {
                cptr = new (addr) SiteSettingsManagerWrapper(cppArg0);
                PySide::setNextQObjectMemoryAddr(nullptr);
            } else {
                cptr = new SiteSettingsManagerWrapper(cppArg0);
            }

            // Ownership transferences (constructor heuristics).
            Shiboken::Object::setParent(pyArgs[0], self);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< SiteSettingsManager >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::Object::setHasCppWrapper(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);

    // QObject setup
    PySide::Signal::updateSourceObject(self);
    metaObject = cptr->metaObject(); // <- init python qt properties
    if (!errInfo.isNull() && PyDict_Check(errInfo.object())) {
        if (!PySide::fillQtProperties(self, metaObject, errInfo, usesPyMI))
            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
    };


    return 1;
}

static PyObject *Sbk_SiteSettingsManagerFunc_adjustUrl(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.SiteSettingsManager.adjustUrl";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static SiteSettingsManager::adjustUrl(QUrl)->QString
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), (pyArg)))) {
        overloadId = 0; // adjustUrl(QUrl)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QUrl cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // adjustUrl(QUrl)
            QString cppResult = ::SiteSettingsManager::adjustUrl(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_SiteSettingsManagerFunc_featureToSqlColumn(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<SiteSettingsManagerWrapper *>(reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.SiteSettingsManager.featureToSqlColumn";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: SiteSettingsManager::featureToSqlColumn(QWebEnginePage::Feature)const->QString
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEnginePage_Feature_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // featureToSqlColumn(QWebEnginePage::Feature)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QWebEnginePage::Feature cppArg0{QWebEnginePage::Notifications};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // featureToSqlColumn(QWebEnginePage::Feature)const
            QString cppResult = const_cast<const SiteSettingsManagerWrapper *>(cppSelf)->featureToSqlColumn(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_SiteSettingsManagerFunc_getDefaultPermission(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<SiteSettingsManagerWrapper *>(reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.SiteSettingsManager.getDefaultPermission";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: SiteSettingsManager::getDefaultPermission(QWebEnginePage::Feature)const->SiteSettingsManager::Permission
    // 1: SiteSettingsManager::getDefaultPermission(QWebEngineSettings::WebAttribute)const->SiteSettingsManager::Permission
    // 2: SiteSettingsManager::getDefaultPermission(SiteSettingsManager::PageOptions)->SiteSettingsManager::Permission
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_PageOptions_IDX])))->converter, (pyArg)))) {
        overloadId = 2; // getDefaultPermission(SiteSettingsManager::PageOptions)
    } else if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_WebAttribute_IDX])))->converter, (pyArg)))) {
        overloadId = 1; // getDefaultPermission(QWebEngineSettings::WebAttribute)const
    } else if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEnginePage_Feature_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // getDefaultPermission(QWebEnginePage::Feature)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // getDefaultPermission(const QWebEnginePage::Feature feature) const
        {
            ::QWebEnginePage::Feature cppArg0{QWebEnginePage::Notifications};
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // getDefaultPermission(QWebEnginePage::Feature)const
                SiteSettingsManager::Permission cppResult = SiteSettingsManager::Permission(const_cast<const SiteSettingsManagerWrapper *>(cppSelf)->getDefaultPermission(cppArg0));
                pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_Permission_IDX])))->converter, &cppResult);
            }
            break;
        }
        case 1: // getDefaultPermission(const QWebEngineSettings::WebAttribute attribute) const
        {
            ::QWebEngineSettings::WebAttribute cppArg0{QWebEngineSettings::AutoLoadImages};
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // getDefaultPermission(QWebEngineSettings::WebAttribute)const
                SiteSettingsManager::Permission cppResult = SiteSettingsManager::Permission(const_cast<const SiteSettingsManagerWrapper *>(cppSelf)->getDefaultPermission(cppArg0));
                pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_Permission_IDX])))->converter, &cppResult);
            }
            break;
        }
        case 2: // getDefaultPermission(const SiteSettingsManager::PageOptions option)
        {
            ::SiteSettingsManager::PageOptions cppArg0{SiteSettingsManager::poAllowCookies};
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // getDefaultPermission(SiteSettingsManager::PageOptions)
                SiteSettingsManager::Permission cppResult = SiteSettingsManager::Permission(cppSelf->getDefaultPermission(cppArg0));
                pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_Permission_IDX])))->converter, &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_SiteSettingsManagerFunc_getOptionName(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<SiteSettingsManagerWrapper *>(reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.SiteSettingsManager.getOptionName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: SiteSettingsManager::getOptionName(QWebEnginePage::Feature)const->QString
    // 1: SiteSettingsManager::getOptionName(QWebEngineSettings::WebAttribute)const->QString
    // 2: SiteSettingsManager::getOptionName(SiteSettingsManager::PageOptions)const->QString
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_PageOptions_IDX])))->converter, (pyArg)))) {
        overloadId = 2; // getOptionName(SiteSettingsManager::PageOptions)const
    } else if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_WebAttribute_IDX])))->converter, (pyArg)))) {
        overloadId = 1; // getOptionName(QWebEngineSettings::WebAttribute)const
    } else if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEnginePage_Feature_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // getOptionName(QWebEnginePage::Feature)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // getOptionName(const QWebEnginePage::Feature feature) const
        {
            ::QWebEnginePage::Feature cppArg0{QWebEnginePage::Notifications};
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // getOptionName(QWebEnginePage::Feature)const
                QString cppResult = const_cast<const SiteSettingsManagerWrapper *>(cppSelf)->getOptionName(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
            }
            break;
        }
        case 1: // getOptionName(const QWebEngineSettings::WebAttribute attribute) const
        {
            ::QWebEngineSettings::WebAttribute cppArg0{QWebEngineSettings::AutoLoadImages};
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // getOptionName(QWebEngineSettings::WebAttribute)const
                QString cppResult = const_cast<const SiteSettingsManagerWrapper *>(cppSelf)->getOptionName(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
            }
            break;
        }
        case 2: // getOptionName(const SiteSettingsManager::PageOptions option) const
        {
            ::SiteSettingsManager::PageOptions cppArg0{SiteSettingsManager::poAllowCookies};
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // getOptionName(SiteSettingsManager::PageOptions)const
                QString cppResult = const_cast<const SiteSettingsManagerWrapper *>(cppSelf)->getOptionName(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_SiteSettingsManagerFunc_getPermission(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<SiteSettingsManagerWrapper *>(reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.SiteSettingsManager.getPermission";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "getPermission", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: SiteSettingsManager::getPermission(QString,QString)->SiteSettingsManager::Permission
    // 1: SiteSettingsManager::getPermission(QString,QUrl)->SiteSettingsManager::Permission
    // 2: SiteSettingsManager::getPermission(QWebEnginePage::Feature,QString)->SiteSettingsManager::Permission
    // 3: SiteSettingsManager::getPermission(QWebEnginePage::Feature,QUrl)->SiteSettingsManager::Permission
    // 4: SiteSettingsManager::getPermission(QWebEngineSettings::WebAttribute,QString)->SiteSettingsManager::Permission
    // 5: SiteSettingsManager::getPermission(QWebEngineSettings::WebAttribute,QUrl)->SiteSettingsManager::Permission
    // 6: SiteSettingsManager::getPermission(SiteSettingsManager::PageOptions,QString)->SiteSettingsManager::Permission
    // 7: SiteSettingsManager::getPermission(SiteSettingsManager::PageOptions,QUrl)->SiteSettingsManager::Permission
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_PageOptions_IDX])))->converter, (pyArgs[0])))) {
        if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
            overloadId = 6; // getPermission(SiteSettingsManager::PageOptions,QString)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), (pyArgs[1])))) {
            overloadId = 7; // getPermission(SiteSettingsManager::PageOptions,QUrl)
        }
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_WebAttribute_IDX])))->converter, (pyArgs[0])))) {
        if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
            overloadId = 4; // getPermission(QWebEngineSettings::WebAttribute,QString)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), (pyArgs[1])))) {
            overloadId = 5; // getPermission(QWebEngineSettings::WebAttribute,QUrl)
        }
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEnginePage_Feature_IDX])))->converter, (pyArgs[0])))) {
        if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
            overloadId = 2; // getPermission(QWebEnginePage::Feature,QString)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), (pyArgs[1])))) {
            overloadId = 3; // getPermission(QWebEnginePage::Feature,QUrl)
        }
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
            overloadId = 0; // getPermission(QString,QString)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), (pyArgs[1])))) {
            overloadId = 1; // getPermission(QString,QUrl)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // getPermission(const QString & column, const QString & host)
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // getPermission(QString,QString)
                SiteSettingsManager::Permission cppResult = SiteSettingsManager::Permission(cppSelf->getPermission(cppArg0, cppArg1));
                pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_Permission_IDX])))->converter, &cppResult);
            }
            break;
        }
        case 1: // getPermission(const QString & column, const QUrl & url)
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QUrl cppArg1_local;
            ::QUrl *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (Shiboken::Errors::occurred() == nullptr) {
                // getPermission(QString,QUrl)
                SiteSettingsManager::Permission cppResult = SiteSettingsManager::Permission(cppSelf->getPermission(cppArg0, *cppArg1));
                pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_Permission_IDX])))->converter, &cppResult);
            }
            break;
        }
        case 2: // getPermission(const QWebEnginePage::Feature feature, const QString & host)
        {
            ::QWebEnginePage::Feature cppArg0{QWebEnginePage::Notifications};
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // getPermission(QWebEnginePage::Feature,QString)
                SiteSettingsManager::Permission cppResult = SiteSettingsManager::Permission(cppSelf->getPermission(cppArg0, cppArg1));
                pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_Permission_IDX])))->converter, &cppResult);
            }
            break;
        }
        case 3: // getPermission(const QWebEnginePage::Feature feature, const QUrl & url)
        {
            ::QWebEnginePage::Feature cppArg0{QWebEnginePage::Notifications};
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QUrl cppArg1_local;
            ::QUrl *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (Shiboken::Errors::occurred() == nullptr) {
                // getPermission(QWebEnginePage::Feature,QUrl)
                SiteSettingsManager::Permission cppResult = SiteSettingsManager::Permission(cppSelf->getPermission(cppArg0, *cppArg1));
                pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_Permission_IDX])))->converter, &cppResult);
            }
            break;
        }
        case 4: // getPermission(const QWebEngineSettings::WebAttribute attribute, const QString & host)
        {
            ::QWebEngineSettings::WebAttribute cppArg0{QWebEngineSettings::AutoLoadImages};
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // getPermission(QWebEngineSettings::WebAttribute,QString)
                SiteSettingsManager::Permission cppResult = SiteSettingsManager::Permission(cppSelf->getPermission(cppArg0, cppArg1));
                pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_Permission_IDX])))->converter, &cppResult);
            }
            break;
        }
        case 5: // getPermission(const QWebEngineSettings::WebAttribute attribute, const QUrl & url)
        {
            ::QWebEngineSettings::WebAttribute cppArg0{QWebEngineSettings::AutoLoadImages};
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QUrl cppArg1_local;
            ::QUrl *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (Shiboken::Errors::occurred() == nullptr) {
                // getPermission(QWebEngineSettings::WebAttribute,QUrl)
                SiteSettingsManager::Permission cppResult = SiteSettingsManager::Permission(cppSelf->getPermission(cppArg0, *cppArg1));
                pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_Permission_IDX])))->converter, &cppResult);
            }
            break;
        }
        case 6: // getPermission(const SiteSettingsManager::PageOptions option, const QString & host)
        {
            ::SiteSettingsManager::PageOptions cppArg0{SiteSettingsManager::poAllowCookies};
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // getPermission(SiteSettingsManager::PageOptions,QString)
                SiteSettingsManager::Permission cppResult = SiteSettingsManager::Permission(cppSelf->getPermission(cppArg0, cppArg1));
                pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_Permission_IDX])))->converter, &cppResult);
            }
            break;
        }
        case 7: // getPermission(const SiteSettingsManager::PageOptions option, const QUrl & url)
        {
            ::SiteSettingsManager::PageOptions cppArg0{SiteSettingsManager::poAllowCookies};
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QUrl cppArg1_local;
            ::QUrl *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (Shiboken::Errors::occurred() == nullptr) {
                // getPermission(SiteSettingsManager::PageOptions,QUrl)
                SiteSettingsManager::Permission cppResult = SiteSettingsManager::Permission(cppSelf->getPermission(cppArg0, *cppArg1));
                pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_Permission_IDX])))->converter, &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_SiteSettingsManagerFunc_getPermissionName(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<SiteSettingsManagerWrapper *>(reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.SiteSettingsManager.getPermissionName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: SiteSettingsManager::getPermissionName(SiteSettingsManager::Permission)const->QString
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_Permission_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // getPermissionName(SiteSettingsManager::Permission)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::SiteSettingsManager::Permission cppArg0{SiteSettingsManager::Default};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // getPermissionName(SiteSettingsManager::Permission)const
            QString cppResult = const_cast<const SiteSettingsManagerWrapper *>(cppSelf)->getPermissionName(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_SiteSettingsManagerFunc_getPermissionsLike(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<SiteSettingsManagerWrapper *>(reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.SiteSettingsManager.getPermissionsLike";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "getPermissionsLike", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: SiteSettingsManager::getPermissionsLike(QString,QString)->QMap< QString,SiteSettingsManager::Permission>
    // 1: SiteSettingsManager::getPermissionsLike(SiteSettingsManager::PageOptions,QString)->QMap< QString,SiteSettingsManager::Permission>
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_PageOptions_IDX])))->converter, (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
        overloadId = 1; // getPermissionsLike(SiteSettingsManager::PageOptions,QString)
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
        overloadId = 0; // getPermissionsLike(QString,QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // getPermissionsLike(const QString & column, const QString & host)
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // getPermissionsLike(QString,QString)
                QMap<QString,SiteSettingsManager::Permission> cppResult = cppSelf->getPermissionsLike(cppArg0, cppArg1);
                pyResult = Shiboken::Conversions::copyToPython(SbkPyFalkonTypeConverters[SBK_PyFalkon_QMap_QString_SiteSettingsManager_Permission_IDX], &cppResult);
            }
            break;
        }
        case 1: // getPermissionsLike(const SiteSettingsManager::PageOptions option, const QString & host)
        {
            ::SiteSettingsManager::PageOptions cppArg0{SiteSettingsManager::poAllowCookies};
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // getPermissionsLike(SiteSettingsManager::PageOptions,QString)
                QMap<QString,SiteSettingsManager::Permission> cppResult = cppSelf->getPermissionsLike(cppArg0, cppArg1);
                pyResult = Shiboken::Conversions::copyToPython(SbkPyFalkonTypeConverters[SBK_PyFalkon_QMap_QString_SiteSettingsManager_Permission_IDX], &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_SiteSettingsManagerFunc_getSiteSettings(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<SiteSettingsManagerWrapper *>(reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.SiteSettingsManager.getSiteSettings";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: SiteSettingsManager::getSiteSettings(QUrl&)->SiteSettingsManager::SiteSettings
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), (pyArg)))) {
        overloadId = 0; // getSiteSettings(QUrl&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QUrl cppArg0_local;
        ::QUrl *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // getSiteSettings(QUrl&)
            SiteSettingsManager::SiteSettings cppResult = cppSelf->getSiteSettings(*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_SiteSettings_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_SiteSettingsManagerFunc_getSupportedAttribute(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<SiteSettingsManagerWrapper *>(reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.SiteSettingsManager.getSupportedAttribute";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // getSupportedAttribute()const
            QList<QWebEngineSettings::WebAttribute> cppResult = const_cast<const SiteSettingsManagerWrapper *>(cppSelf)->getSupportedAttribute();
            pyResult = Shiboken::Conversions::copyToPython(SbkPyFalkonTypeConverters[SBK_PyFalkon_QList_QWebEngineSettings_WebAttribute_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_SiteSettingsManagerFunc_getSupportedFeatures(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<SiteSettingsManagerWrapper *>(reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.SiteSettingsManager.getSupportedFeatures";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // getSupportedFeatures()const
            QList<QWebEnginePage::Feature> cppResult = const_cast<const SiteSettingsManagerWrapper *>(cppSelf)->getSupportedFeatures();
            pyResult = Shiboken::Conversions::copyToPython(SbkPyFalkonTypeConverters[SBK_PyFalkon_QList_QWebEnginePage_Feature_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_SiteSettingsManagerFunc_getWebAttributes(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<SiteSettingsManagerWrapper *>(reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.SiteSettingsManager.getWebAttributes";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: SiteSettingsManager::getWebAttributes(QUrl)->QHash< QWebEngineSettings::WebAttribute,bool>
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), (pyArg)))) {
        overloadId = 0; // getWebAttributes(QUrl)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QUrl cppArg0_local;
        ::QUrl *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // getWebAttributes(QUrl)
            QHash<QWebEngineSettings::WebAttribute,bool> cppResult = cppSelf->getWebAttributes(*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPyFalkonTypeConverters[SBK_PyFalkon_QHash_QWebEngineSettings_WebAttribute_bool_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_SiteSettingsManagerFunc_intToPermission(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<SiteSettingsManagerWrapper *>(reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.SiteSettingsManager.intToPermission";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: SiteSettingsManager::intToPermission(int)const->SiteSettingsManager::Permission
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // intToPermission(int)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // intToPermission(int)const
            SiteSettingsManager::Permission cppResult = SiteSettingsManager::Permission(const_cast<const SiteSettingsManagerWrapper *>(cppSelf)->intToPermission(cppArg0));
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_Permission_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_SiteSettingsManagerFunc_loadSettings(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<SiteSettingsManagerWrapper *>(reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PyFalkon.SiteSettingsManager.loadSettings";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // loadSettings()
            cppSelf->loadSettings();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_SiteSettingsManagerFunc_optionToSqlColumn(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<SiteSettingsManagerWrapper *>(reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.SiteSettingsManager.optionToSqlColumn";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: SiteSettingsManager::optionToSqlColumn(SiteSettingsManager::PageOptions)const->QString
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_PageOptions_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // optionToSqlColumn(SiteSettingsManager::PageOptions)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::SiteSettingsManager::PageOptions cppArg0{SiteSettingsManager::poAllowCookies};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // optionToSqlColumn(SiteSettingsManager::PageOptions)const
            QString cppResult = const_cast<const SiteSettingsManagerWrapper *>(cppSelf)->optionToSqlColumn(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_SiteSettingsManagerFunc_saveSettings(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<SiteSettingsManagerWrapper *>(reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PyFalkon.SiteSettingsManager.saveSettings";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // saveSettings()
            cppSelf->saveSettings();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_SiteSettingsManagerFunc_setOption(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<SiteSettingsManagerWrapper *>(reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.SiteSettingsManager.setOption";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "setOption", 3, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return {};


    // Overloaded function decisor
    // 0: SiteSettingsManager::setOption(QString,QUrl,int)
    // 1: SiteSettingsManager::setOption(QWebEnginePage::Feature,QUrl,SiteSettingsManager::Permission)
    // 2: SiteSettingsManager::setOption(QWebEngineSettings::WebAttribute,QUrl,SiteSettingsManager::Permission)
    // 3: SiteSettingsManager::setOption(SiteSettingsManager::PageOptions,QUrl,int)
    if (numArgs == 3
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_PageOptions_IDX])))->converter, (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[2])))) {
        overloadId = 3; // setOption(SiteSettingsManager::PageOptions,QUrl,int)
    } else if (numArgs == 3
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_WebAttribute_IDX])))->converter, (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_Permission_IDX])))->converter, (pyArgs[2])))) {
        overloadId = 2; // setOption(QWebEngineSettings::WebAttribute,QUrl,SiteSettingsManager::Permission)
    } else if (numArgs == 3
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEnginePage_Feature_IDX])))->converter, (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_Permission_IDX])))->converter, (pyArgs[2])))) {
        overloadId = 1; // setOption(QWebEnginePage::Feature,QUrl,SiteSettingsManager::Permission)
    } else if (numArgs == 3
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[2])))) {
        overloadId = 0; // setOption(QString,QUrl,int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // setOption(const QString & column, const QUrl & url, const int value)
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QUrl cppArg1_local;
            ::QUrl *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);

            int cppArg2;
            pythonToCpp[2](pyArgs[2], &cppArg2);

            if (Shiboken::Errors::occurred() == nullptr) {
                // setOption(QString,QUrl,int)
                cppSelf->setOption(cppArg0, *cppArg1, cppArg2);
            }
            break;
        }
        case 1: // setOption(const QWebEnginePage::Feature & feature, const QUrl & url, const SiteSettingsManager::Permission value)
        {
            ::QWebEnginePage::Feature cppArg0{QWebEnginePage::Notifications};
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QUrl cppArg1_local;
            ::QUrl *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);

            ::SiteSettingsManager::Permission cppArg2{SiteSettingsManager::Default};
            pythonToCpp[2](pyArgs[2], &cppArg2);

            if (Shiboken::Errors::occurred() == nullptr) {
                // setOption(QWebEnginePage::Feature,QUrl,SiteSettingsManager::Permission)
                cppSelf->setOption(cppArg0, *cppArg1, cppArg2);
            }
            break;
        }
        case 2: // setOption(const QWebEngineSettings::WebAttribute & attribute, const QUrl & url, const SiteSettingsManager::Permission value)
        {
            ::QWebEngineSettings::WebAttribute cppArg0{QWebEngineSettings::AutoLoadImages};
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QUrl cppArg1_local;
            ::QUrl *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);

            ::SiteSettingsManager::Permission cppArg2{SiteSettingsManager::Default};
            pythonToCpp[2](pyArgs[2], &cppArg2);

            if (Shiboken::Errors::occurred() == nullptr) {
                // setOption(QWebEngineSettings::WebAttribute,QUrl,SiteSettingsManager::Permission)
                cppSelf->setOption(cppArg0, *cppArg1, cppArg2);
            }
            break;
        }
        case 3: // setOption(const SiteSettingsManager::PageOptions option, const QUrl & url, const int value)
        {
            ::SiteSettingsManager::PageOptions cppArg0{SiteSettingsManager::poAllowCookies};
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QUrl cppArg1_local;
            ::QUrl *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);

            int cppArg2;
            pythonToCpp[2](pyArgs[2], &cppArg2);

            if (Shiboken::Errors::occurred() == nullptr) {
                // setOption(SiteSettingsManager::PageOptions,QUrl,int)
                cppSelf->setOption(cppArg0, *cppArg1, cppArg2);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_SiteSettingsManagerFunc_setSiteSettings(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<SiteSettingsManagerWrapper *>(reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.SiteSettingsManager.setSiteSettings";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: SiteSettingsManager::setSiteSettings(SiteSettingsManager::SiteSettings&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_SiteSettings_IDX]), (pyArg)))) {
        overloadId = 0; // setSiteSettings(SiteSettingsManager::SiteSettings&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::SiteSettingsManager::SiteSettings cppArg0_local;
        ::SiteSettingsManager::SiteSettings *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setSiteSettings(SiteSettingsManager::SiteSettings&)
            cppSelf->setSiteSettings(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_SiteSettingsManagerFunc_sqlTable(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<SiteSettingsManagerWrapper *>(reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PyFalkon.SiteSettingsManager.sqlTable";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // sqlTable()
            QString cppResult = cppSelf->sqlTable();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_SiteSettingsManagerFunc_webAttributeToSqlColumn(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = static_cast<SiteSettingsManagerWrapper *>(reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self))));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PyFalkon.SiteSettingsManager.webAttributeToSqlColumn";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: SiteSettingsManager::webAttributeToSqlColumn(QWebEngineSettings::WebAttribute)const->QString
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_WebAttribute_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // webAttributeToSqlColumn(QWebEngineSettings::WebAttribute)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QWebEngineSettings::WebAttribute cppArg0{QWebEngineSettings::AutoLoadImages};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // webAttributeToSqlColumn(QWebEngineSettings::WebAttribute)const
            QString cppResult = const_cast<const SiteSettingsManagerWrapper *>(cppSelf)->webAttributeToSqlColumn(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_SiteSettingsManager_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_SiteSettingsManager_EnumFlagInfo[] = {
    "PageOptions:IntEnum",
    "Permission:IntEnum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_SiteSettingsManager_methods[] = {
    {"adjustUrl", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_adjustUrl), METH_O|METH_STATIC, nullptr},
    {"featureToSqlColumn", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_featureToSqlColumn), METH_O, nullptr},
    {"getDefaultPermission", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_getDefaultPermission), METH_O, nullptr},
    {"getOptionName", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_getOptionName), METH_O, nullptr},
    {"getPermission", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_getPermission), METH_VARARGS, nullptr},
    {"getPermissionName", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_getPermissionName), METH_O, nullptr},
    {"getPermissionsLike", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_getPermissionsLike), METH_VARARGS, nullptr},
    {"getSiteSettings", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_getSiteSettings), METH_O, nullptr},
    {"getSupportedAttribute", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_getSupportedAttribute), METH_NOARGS, nullptr},
    {"getSupportedFeatures", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_getSupportedFeatures), METH_NOARGS, nullptr},
    {"getWebAttributes", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_getWebAttributes), METH_O, nullptr},
    {"intToPermission", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_intToPermission), METH_O, nullptr},
    {"loadSettings", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_loadSettings), METH_NOARGS, nullptr},
    {"optionToSqlColumn", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_optionToSqlColumn), METH_O, nullptr},
    {"saveSettings", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_saveSettings), METH_NOARGS, nullptr},
    {"setOption", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_setOption), METH_VARARGS, nullptr},
    {"setSiteSettings", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_setSiteSettings), METH_O, nullptr},
    {"sqlTable", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_sqlTable), METH_NOARGS, nullptr},
    {"webAttributeToSqlColumn", reinterpret_cast<PyCFunction>(Sbk_SiteSettingsManagerFunc_webAttributeToSqlColumn), METH_O, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static int Sbk_SiteSettingsManager_setattro(PyObject *self, PyObject *name, PyObject *value)
{
    PySide::Feature::Select(self);
    if (value != nullptr && PyCallable_Check(value) != 0) {
        auto plain_inst = reinterpret_cast< ::SiteSettingsManager *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX]), reinterpret_cast<SbkObject *>(self)));
        auto *inst = dynamic_cast<SiteSettingsManagerWrapper *>(plain_inst);
        if (inst != nullptr)
            inst->resetPyMethodCache();
    }
    Shiboken::AutoDecRef pp(reinterpret_cast<PyObject *>(PySide::Property::getObject(self, name)));
    if (!pp.isNull())
        return PySide::Property::setValue(reinterpret_cast<PySideProperty *>(pp.object()), self, value);
    return PyObject_GenericSetAttr(self, name, value);
}

} // extern "C"

static int Sbk_SiteSettingsManager_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_SiteSettingsManager_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_SiteSettingsManager_Type = nullptr;
static PyTypeObject *Sbk_SiteSettingsManager_TypeF(void)
{
    return _Sbk_SiteSettingsManager_Type;
}

static PyType_Slot Sbk_SiteSettingsManager_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_setattro,    reinterpret_cast<void *>(Sbk_SiteSettingsManager_setattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_SiteSettingsManager_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_SiteSettingsManager_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_SiteSettingsManager_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_SiteSettingsManager_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_SiteSettingsManager_spec = {
    "1:PyFalkon.SiteSettingsManager",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_SiteSettingsManager_slots
};

} //extern "C"

static void *Sbk_SiteSettingsManager_typeDiscovery(void *cptr, PyTypeObject *instanceType)
{
    SBK_UNUSED(cptr)
    SBK_UNUSED(instanceType)
    if (instanceType == Shiboken::SbkType< ::QObject >())
        return dynamic_cast< ::SiteSettingsManager *>(reinterpret_cast< ::QObject *>(cptr));
    return {};
}


// Type conversion functions.

// Python to C++ enum conversion.
static void SiteSettingsManager_Permission_PythonToCpp_SiteSettingsManager_Permission(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::SiteSettingsManager::Permission>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::SiteSettingsManager::Permission *>(cppOut) = value;

}
static PythonToCppFunc is_SiteSettingsManager_Permission_PythonToCpp_SiteSettingsManager_Permission_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_Permission_IDX])))
        return SiteSettingsManager_Permission_PythonToCpp_SiteSettingsManager_Permission;
    return {};
}
static PyObject *SiteSettingsManager_Permission_CppToPython_SiteSettingsManager_Permission(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::SiteSettingsManager::Permission *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_Permission_IDX]), castCppIn);

}

static void SiteSettingsManager_PageOptions_PythonToCpp_SiteSettingsManager_PageOptions(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::SiteSettingsManager::PageOptions>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::SiteSettingsManager::PageOptions *>(cppOut) = value;

}
static PythonToCppFunc is_SiteSettingsManager_PageOptions_PythonToCpp_SiteSettingsManager_PageOptions_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_PageOptions_IDX])))
        return SiteSettingsManager_PageOptions_PythonToCpp_SiteSettingsManager_PageOptions;
    return {};
}
static PyObject *SiteSettingsManager_PageOptions_CppToPython_SiteSettingsManager_PageOptions(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::SiteSettingsManager::PageOptions *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_PageOptions_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void SiteSettingsManager_PythonToCpp_SiteSettingsManager_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_SiteSettingsManager_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_SiteSettingsManager_PythonToCpp_SiteSettingsManager_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_SiteSettingsManager_TypeF()))
        return SiteSettingsManager_PythonToCpp_SiteSettingsManager_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *SiteSettingsManager_PTR_CppToPython_SiteSettingsManager(const void *cppIn)
{
    return PySide::getWrapperForQObject(reinterpret_cast<::SiteSettingsManager *>(const_cast<void *>(cppIn)), Sbk_SiteSettingsManager_TypeF());

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *SiteSettingsManager_SignatureStrings[] = {
    "PyFalkon.SiteSettingsManager(self,parent:PySide6.QtCore.QObject=nullptr)",
    "PyFalkon.SiteSettingsManager.adjustUrl(url:typing.Union[PySide6.QtCore.QUrl, QString])->QString",
    "PyFalkon.SiteSettingsManager.featureToSqlColumn(self,feature:PySide6.QtWebEngineCore.QWebEnginePage.Feature)->QString",
    "2:PyFalkon.SiteSettingsManager.getDefaultPermission(self,feature:PySide6.QtWebEngineCore.QWebEnginePage.Feature)->PyFalkon.SiteSettingsManager.Permission",
    "1:PyFalkon.SiteSettingsManager.getDefaultPermission(self,attribute:PySide6.QtWebEngineCore.QWebEngineSettings.WebAttribute)->PyFalkon.SiteSettingsManager.Permission",
    "0:PyFalkon.SiteSettingsManager.getDefaultPermission(self,option:PyFalkon.SiteSettingsManager.PageOptions)->PyFalkon.SiteSettingsManager.Permission",
    "2:PyFalkon.SiteSettingsManager.getOptionName(self,feature:PySide6.QtWebEngineCore.QWebEnginePage.Feature)->QString",
    "1:PyFalkon.SiteSettingsManager.getOptionName(self,attribute:PySide6.QtWebEngineCore.QWebEngineSettings.WebAttribute)->QString",
    "0:PyFalkon.SiteSettingsManager.getOptionName(self,option:PyFalkon.SiteSettingsManager.PageOptions)->QString",
    "7:PyFalkon.SiteSettingsManager.getPermission(self,column:QString,host:QString)->PyFalkon.SiteSettingsManager.Permission",
    "6:PyFalkon.SiteSettingsManager.getPermission(self,column:QString,url:typing.Union[PySide6.QtCore.QUrl, QString])->PyFalkon.SiteSettingsManager.Permission",
    "5:PyFalkon.SiteSettingsManager.getPermission(self,feature:PySide6.QtWebEngineCore.QWebEnginePage.Feature,host:QString)->PyFalkon.SiteSettingsManager.Permission",
    "4:PyFalkon.SiteSettingsManager.getPermission(self,feature:PySide6.QtWebEngineCore.QWebEnginePage.Feature,url:typing.Union[PySide6.QtCore.QUrl, QString])->PyFalkon.SiteSettingsManager.Permission",
    "3:PyFalkon.SiteSettingsManager.getPermission(self,attribute:PySide6.QtWebEngineCore.QWebEngineSettings.WebAttribute,host:QString)->PyFalkon.SiteSettingsManager.Permission",
    "2:PyFalkon.SiteSettingsManager.getPermission(self,attribute:PySide6.QtWebEngineCore.QWebEngineSettings.WebAttribute,url:typing.Union[PySide6.QtCore.QUrl, QString])->PyFalkon.SiteSettingsManager.Permission",
    "1:PyFalkon.SiteSettingsManager.getPermission(self,option:PyFalkon.SiteSettingsManager.PageOptions,host:QString)->PyFalkon.SiteSettingsManager.Permission",
    "0:PyFalkon.SiteSettingsManager.getPermission(self,option:PyFalkon.SiteSettingsManager.PageOptions,url:typing.Union[PySide6.QtCore.QUrl, QString])->PyFalkon.SiteSettingsManager.Permission",
    "PyFalkon.SiteSettingsManager.getPermissionName(self,permission:PyFalkon.SiteSettingsManager.Permission)->QString",
    "1:PyFalkon.SiteSettingsManager.getPermissionsLike(self,column:QString,host:QString)->QMap[QString, PyFalkon.SiteSettingsManager.Permission]",
    "0:PyFalkon.SiteSettingsManager.getPermissionsLike(self,option:PyFalkon.SiteSettingsManager.PageOptions,host:QString)->QMap[QString, PyFalkon.SiteSettingsManager.Permission]",
    "PyFalkon.SiteSettingsManager.getSiteSettings(self,url:typing.Union[PySide6.QtCore.QUrl, QString])->PyFalkon.SiteSettingsManager.SiteSettings",
    "PyFalkon.SiteSettingsManager.getSupportedAttribute(self)->QList[PySide6.QtWebEngineCore.QWebEngineSettings.WebAttribute]",
    "PyFalkon.SiteSettingsManager.getSupportedFeatures(self)->QList[PySide6.QtWebEngineCore.QWebEnginePage.Feature]",
    "PyFalkon.SiteSettingsManager.getWebAttributes(self,url:typing.Union[PySide6.QtCore.QUrl, QString])->QHash[PySide6.QtWebEngineCore.QWebEngineSettings.WebAttribute, bool]",
    "PyFalkon.SiteSettingsManager.intToPermission(self,permission:int)->PyFalkon.SiteSettingsManager.Permission",
    "PyFalkon.SiteSettingsManager.loadSettings(self)",
    "PyFalkon.SiteSettingsManager.optionToSqlColumn(self,option:PyFalkon.SiteSettingsManager.PageOptions)->QString",
    "PyFalkon.SiteSettingsManager.saveSettings(self)",
    "3:PyFalkon.SiteSettingsManager.setOption(self,column:QString,url:typing.Union[PySide6.QtCore.QUrl, QString],value:int)",
    "2:PyFalkon.SiteSettingsManager.setOption(self,feature:PySide6.QtWebEngineCore.QWebEnginePage.Feature,url:typing.Union[PySide6.QtCore.QUrl, QString],value:PyFalkon.SiteSettingsManager.Permission)",
    "1:PyFalkon.SiteSettingsManager.setOption(self,attribute:PySide6.QtWebEngineCore.QWebEngineSettings.WebAttribute,url:typing.Union[PySide6.QtCore.QUrl, QString],value:PyFalkon.SiteSettingsManager.Permission)",
    "0:PyFalkon.SiteSettingsManager.setOption(self,option:PyFalkon.SiteSettingsManager.PageOptions,url:typing.Union[PySide6.QtCore.QUrl, QString],value:int)",
    "PyFalkon.SiteSettingsManager.setSiteSettings(self,siteSettings:PyFalkon.SiteSettingsManager.SiteSettings)",
    "PyFalkon.SiteSettingsManager.sqlTable(self)->QString",
    "PyFalkon.SiteSettingsManager.webAttributeToSqlColumn(self,attribute:PySide6.QtWebEngineCore.QWebEngineSettings.WebAttribute)->QString",
    nullptr}; // Sentinel

PyTypeObject *init_SiteSettingsManager(PyObject *module)
{
    if (SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX].type != nullptr)
        return SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX].type;

    Shiboken::AutoDecRef Sbk_SiteSettingsManager_Type_bases(PyTuple_Pack(1,
        reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]))));

    _Sbk_SiteSettingsManager_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "SiteSettingsManager",
        "SiteSettingsManager*",
        &Sbk_SiteSettingsManager_spec,
        &Shiboken::callCppDestructor< SiteSettingsManager >,
        Sbk_SiteSettingsManager_Type_bases.object(),
        0);
    auto *pyType = Sbk_SiteSettingsManager_TypeF(); // references _Sbk_SiteSettingsManager_Type
    InitSignatureStrings(pyType, SiteSettingsManager_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_SiteSettingsManager_PropertyStrings);
    SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        SiteSettingsManager_PythonToCpp_SiteSettingsManager_PTR,
        is_SiteSettingsManager_PythonToCpp_SiteSettingsManager_PTR_Convertible,
        SiteSettingsManager_PTR_CppToPython_SiteSettingsManager);

    Shiboken::Conversions::registerConverterName(converter, "SiteSettingsManager");
    Shiboken::Conversions::registerConverterName(converter, "SiteSettingsManager*");
    Shiboken::Conversions::registerConverterName(converter, "SiteSettingsManager&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::SiteSettingsManager).name());
    Shiboken::Conversions::registerConverterName(converter, typeid(SiteSettingsManagerWrapper).name());

    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(
        Sbk_SiteSettingsManager_TypeF(), &Sbk_SiteSettingsManager_typeDiscovery);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_SiteSettingsManager_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Permission'.
    const char *Permission_Initializer[] = {
        "Default",
        "Allow",
        "Deny",
        "Ask",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t Permission_InitializerValues[] = {
        uint8_t(SiteSettingsManager::Permission::Default), //  0x00  0
        uint8_t(SiteSettingsManager::Permission::Allow),   //  0x01  1
        uint8_t(SiteSettingsManager::Permission::Deny),    //  0x02  2
        uint8_t(SiteSettingsManager::Permission::Ask)      //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_SiteSettingsManager_TypeF(),
        "1:PyFalkon.SiteSettingsManager.Permission",
        Permission_Initializer, Permission_InitializerValues);
    SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_Permission_IDX].type = EType;
    // Register converter for enum 'SiteSettingsManager::Permission'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            SiteSettingsManager_Permission_CppToPython_SiteSettingsManager_Permission);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            SiteSettingsManager_Permission_PythonToCpp_SiteSettingsManager_Permission,
            is_SiteSettingsManager_Permission_PythonToCpp_SiteSettingsManager_Permission_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "SiteSettingsManager::Permission");
        Shiboken::Conversions::registerConverterName(converter, "Permission");
    }
    // End of 'Permission' enum.

    // Initialization of enum 'PageOptions'.
    const char *PageOptions_Initializer[] = {
        "poAllowCookies",
        "poZoomLevel",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t PageOptions_InitializerValues[] = {
        uint8_t(SiteSettingsManager::PageOptions::poAllowCookies), //  0x00  0
        uint8_t(SiteSettingsManager::PageOptions::poZoomLevel)     //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_SiteSettingsManager_TypeF(),
        "1:PyFalkon.SiteSettingsManager.PageOptions",
        PageOptions_Initializer, PageOptions_InitializerValues);
    SbkPyFalkonTypeStructs[SBK_SiteSettingsManager_PageOptions_IDX].type = EType;
    // Register converter for enum 'SiteSettingsManager::PageOptions'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            SiteSettingsManager_PageOptions_CppToPython_SiteSettingsManager_PageOptions);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            SiteSettingsManager_PageOptions_PythonToCpp_SiteSettingsManager_PageOptions,
            is_SiteSettingsManager_PageOptions_PythonToCpp_SiteSettingsManager_PageOptions_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "SiteSettingsManager::PageOptions");
        Shiboken::Conversions::registerConverterName(converter, "PageOptions");
    }
    // End of 'PageOptions' enum.

    SiteSettingsManagerWrapper::pysideInitQtMetaTypes();
    Shiboken::ObjectType::setSubTypeInitHook(pyType, &PySide::initQObjectSubType);
    PySide::initDynamicMetaObject(pyType, &::SiteSettingsManager::staticMetaObject, sizeof(SiteSettingsManagerWrapper));

    return pyType;
}
